from gtk import *
import string
import gtk
import gobject
import sys
import functions
import rhpl.iconv
import os

##
## I18N
## 
#import gettext
#gettext.bindtextdomain ("firstboot", "/usr/share/locale")
#gettext.textdomain ("firstboot")
#_=gettext.gettext

from rhpl.translate import _, N_
from rhpl import translate
translate.textdomain("firstboot")

from firstboot_module_window import FirstbootModuleWindow


class CernWindow(FirstbootModuleWindow):
    #You must specify a runPriority for the order in which you wish your module to run
    runPriority = 401
    moduleName = (_("CERN customization"))
    windowTitle = (_("CERN customization"))
    shortMessage = (_("Welcome to CERN custom settings"))
    

    def launch(self, doDebug = None):
        self.doDebug = doDebug
        if self.doDebug:
            print "initializing CERN customization module"

        self.mainVBox = gtk.VBox()
        #self.mainVBox.set_size_request(500, 300)

        self.icon = functions.imageFromFile("cern-workstation.png")

        internalVBox = gtk.VBox()
        internalVBox.set_border_width(10)
        internalVBox.set_spacing(5)

        label = gtk.Label(_("For CERN systems (or systems being installed on CERN site)\n"
                            "we provide a predefined setup (AFS/Kerberos/time servers etc)\n"
                            "customized to fulfill a specific set of requirements.\n"
                            "\n"
                            "You should select this default if your machine is at CERN\n" ))

        label.set_line_wrap(True)
        label.set_alignment(0.0, 1)
        label.set_size_request(500, -1)
            
        self.okButton = gtk.RadioButton(None, (_("_Yes, customize my system for CERN")))
        self.okButton.set_active(True)

        self.afsCheckButton = gtk.CheckButton(_("Start _AFS on system boot"))
        afsAlign = gtk.Alignment(0.2,0,0.2,0)
        afsAlign.add(self.afsCheckButton)
        self.afsCheckButton.set_active(True)
        
        self.doupdateButton = gtk.RadioButton(None,(_("Enable automatic system _updates")))
        doupdAlign = gtk.Alignment(0.2,0,0.2,0)
        doupdAlign.add(self.doupdateButton)
        self.doupdateButton.set_active(True)
        
        self.checkupdButton = gtk.RadioButton(self.doupdateButton, (_("Enable automatic _check for updates")))
        checkupdAlign = gtk.Alignment(0.2,0,0.2,0)
        checkupdAlign.add(self.checkupdButton)

        self.noButton = gtk.RadioButton(self.okButton, (_("N_o, I will do setup myself")))

        self.extdoupdateButton = gtk.RadioButton(None,(_("Enable automatic system _updates")))
        doextupdAlign = gtk.Alignment(0.2,0,0.2,0)
        doextupdAlign.add(self.extdoupdateButton)
        self.extdoupdateButton.set_active(True)
        self.extdoupdateButton.set_sensitive(False)

        self.checkextButton = gtk.RadioButton(self.extdoupdateButton,_("Enable automatic _check for updates"))
        checkextAlign = gtk.Alignment(0.2,0,0.2,0)
        checkextAlign.add(self.checkextButton)
        self.checkextButton.set_active(False)
        self.checkextButton.set_sensitive(False) 

        label2 = gtk.Label(_("\n"))
#\n\nNOTE:\n\nBefore CEL3 is adopted as CERN Recommended Linux\n"
#                             "version this setup screen may be updated to permit\n"
#                             "more fine-grained customization of your CERN system\n" ))

	label2.set_line_wrap(True)
        label2.set_alignment(0.0, 1)
        label2.set_size_request(500, -1)

#        internalVBox.pack_start(textSW, True)
        internalVBox.pack_start(label, False, True)
        internalVBox.pack_start(self.okButton, False)
        internalVBox.pack_start(afsAlign, False, 10)
        internalVBox.pack_start(doupdAlign, False, 10)
        internalVBox.pack_start(checkupdAlign, False, 10)
        internalVBox.pack_start(self.noButton, False)
        internalVBox.pack_start(doextupdAlign, False, 10)
        internalVBox.pack_start(checkextAlign, False, 10)
        internalVBox.pack_start(label2, False, True)
        
        self.okButton.connect("clicked", self.okButtonClicked)
        self.noButton.connect("clicked", self.noButtonClicked)

        self.mainVBox.pack_start(internalVBox, True, 5)
        return self.mainVBox, self.icon, self.windowTitle
     
    def okButtonClicked (self, args):
        self.afsCheckButton.set_sensitive(self.okButton.get_active())
        self.doupdateButton.set_sensitive(self.okButton.get_active())
        self.checkupdButton.set_sensitive(self.okButton.get_active())

    def noButtonClicked (self, args):
        self.checkextButton.set_sensitive(self.noButton.get_active())
        self.extdoupdateButton.set_sensitive(self.noButton.get_active())
 
    def apply(self, notebook):
    #    dlg = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_OK,
    #                            _("Your system will be preconfigured for CERN use\n"
    #                            "Some existing configuration files will be overwritten\n"
    #                            "(backup copies will be stored as .cern-preconf-bak)\n"))
    #    dlg.set_position(gtk.WIN_POS_CENTER)
    #    dlg.set_modal(True)
    #    dlg.show_all()
    #    result = dlg.run()

        (status,output) = self.checkStatusOutput("/bin/rm -f /etc/sysconfig/lcm-firstboot")
   
        if self.okButton.get_active() == True:
            (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_START=yes > /etc/sysconfig/lcm-firstboot")
            (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_COMPONENTS=1 >> /etc/sysconfig/lcm-firstboot")            
            if self.afsCheckButton.get_active() == True:
                (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_STARTAFS=yes >> /etc/sysconfig/lcm-firstboot")
            else:
                (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_STARTAFS=no >> /etc/sysconfig/lcm-firstboot")
            if self.checkupdButton.get_active() == True:
                (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_UPDATE=0 >> /etc/sysconfig/lcm-firstboot")
            if self.doupdateButton.get_active() == True:
                (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_UPDATE=1 >> /etc/sysconfig/lcm-firstboot")
 
	else:
             (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_START=yes > /etc/sysconfig/lcm-firstboot")
             (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_COMPONENTS=0 >> /etc/sysconfig/lcm-firstboot")
             (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_STARTAFS=no >> /etc/sysconfig/lcm-firstboot")
             if self.extdoupdateButton.get_active() == True:
                 (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_UPDATE=1 >> /etc/sysconfig/lcm-firstboot")
             if self.checkextButton.get_active() == True:
                 (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_UPDATE=0 >> /etc/sysconfig/lcm-firstboot") 

        return 0

    def checkStatusOutput (self, cmdline):
        "checking both status and output of the cmdline expression"
        from commands import getstatusoutput
        (status, output) = getstatusoutput(cmdline)
        return (status,output)

childWindow=CernWindow
